package com.hai.dao;

import com.hai.entity.HighActivityAward;
import com.hai.entity.HighActivityAwardExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighActivityAwardMapper extends HighActivityAwardMapperExt {
    @SelectProvider(type=HighActivityAwardSqlProvider.class, method="countByExample")
    long countByExample(HighActivityAwardExample example);

    @DeleteProvider(type=HighActivityAwardSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighActivityAwardExample example);

    @Delete({
        "delete from high_activity_award",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_activity_award (activity_info_id, img, ",
        "`name`, num, `status`, ",
        "create_time, update_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{activityInfoId,jdbcType=BIGINT}, #{img,jdbcType=VARCHAR}, ",
        "#{name,jdbcType=VARCHAR}, #{num,jdbcType=INTEGER}, #{status,jdbcType=INTEGER}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighActivityAward record);

    @InsertProvider(type=HighActivityAwardSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighActivityAward record);

    @SelectProvider(type=HighActivityAwardSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="activity_info_id", property="activityInfoId", jdbcType=JdbcType.BIGINT),
        @Result(column="img", property="img", jdbcType=JdbcType.VARCHAR),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="num", property="num", jdbcType=JdbcType.INTEGER),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighActivityAward> selectByExample(HighActivityAwardExample example);

    @Select({
        "select",
        "id, activity_info_id, img, `name`, num, `status`, create_time, update_time, ",
        "ext_1, ext_2, ext_3",
        "from high_activity_award",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="activity_info_id", property="activityInfoId", jdbcType=JdbcType.BIGINT),
        @Result(column="img", property="img", jdbcType=JdbcType.VARCHAR),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="num", property="num", jdbcType=JdbcType.INTEGER),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighActivityAward selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighActivityAwardSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighActivityAward record, @Param("example") HighActivityAwardExample example);

    @UpdateProvider(type=HighActivityAwardSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighActivityAward record, @Param("example") HighActivityAwardExample example);

    @UpdateProvider(type=HighActivityAwardSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighActivityAward record);

    @Update({
        "update high_activity_award",
        "set activity_info_id = #{activityInfoId,jdbcType=BIGINT},",
          "img = #{img,jdbcType=VARCHAR},",
          "`name` = #{name,jdbcType=VARCHAR},",
          "num = #{num,jdbcType=INTEGER},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighActivityAward record);
}